VR-Forces Developer's Guide
 All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Friends Macros Groups Pages
railPathControllerPSR.h
Go to the documentation of this file.
1 /*******************************************************************************
2 ** Copyright (c) 2015 MAK Technologies, Inc.
3 ** All rights reserved.
4 *******************************************************************************/
5 
8 
9 #pragma once
10 
12 #include "vrfobjcore/simObject.h"
13 #include "readerWriter/rwVector.h"
14 #include <readerWriter/rwString.h>
15 #include <readerWriter/rwInt.h>
17 #include "vrfutil/rwRailSegment.h"
18 #include <vrfutil/rwUUID.h>
20 
26 
29 {
30 public:
33  const DtString& rwName = DtString::nullString(),
34  DtReaderWriterRegistry* parentRegistry = 0);
35 
38  const DtString& rwName = DtString::nullString(),
39  DtReaderWriterRegistry* parentRegistry = 0);
40 
42  virtual ~DtRailPathControllerPSR() override;
43 
46 
49  const DtString& rwName = DtString::nullString(), DtReaderWriterRegistry* parentRegistry = 0) const override;
50 
52  virtual DtString type() const override;
53 
54  virtual void clear();
55 
56  virtual void clearPath();
57 
60  virtual const DtRwRailSegmentList& pathList() const;
61  virtual DtRwRailSegmentList& pathList();
62  virtual void addSegmentToPath(const DtRailSegment& seg,bool appendToEnd = true);
63  virtual void addRailSegments(DtRailSegmentList*);
65 
69  virtual void setDestination(const DtUUID& destination);
70 
72  virtual DtSimObjectReference destination() const;
73 
75  virtual bool destinationSpecified() const;
77  virtual void unspecifyDestination();
79 
83  virtual void setDestinationLocation(const DtVector& destinationLocation);
84  virtual DtVector destinationLocation() const;
86  virtual bool destinationLocationSpecified() const;
88  virtual void unspecifyDestinationLocation();
90 
95  virtual void setDebugPath(const DtUUID&);
96 
99  virtual const DtRwSimObjectReference& debugPath() const;
101  virtual bool debugPathSpecified() const;
103  virtual void unspecifyDebugPath();
105 
106 public:
107 
109  static DtVrfProcessStateRepository* creator (const DtString& rwName,
110  DtLocalObject* vrfObject, DtReaderWriterRegistry* parentRegistry);
111 
112 protected:
113 
122 
132 };
UUID is a unique ID wrapper class.
Definition: uuid.h:59
File: rwRailSegment.h.
std::list< DtRailSegment * > DtRailSegmentList
Definition: railSegment.h:194
DtRailSegment are segments entities can follow when using the rail movement system.
Definition: railSegment.h:20
Definition: readerWriterRegistry.h:39
Contains the DtUUID class declaration.
DtRwVector myDestinationLocation
Parameter Name: destination-location Parameter Description: Stores the geocentric location of the des...
Definition: railPathControllerPSR.h:128
Definition: rwVector.h:23
Specialized reader/writer version of the shared object reference that will encapsulate the actual sha...
Definition: rwSimObjectReference.h:21
#define DT_DLL_vrfobjcore
This file is used to determine how to build.
Definition: vrfobjcoreDefines.h:24
virtual DtVrfProcessStateRepository * clone(const DtString &rwName=DtString::nullString(), DtReaderWriterRegistry *parentRegistry=0) const =0
DtRwSimObjectReference myDestination
Parameter Name: destination-name Parameter Description: Stores the name of the destination object if ...
Definition: railPathControllerPSR.h:125
class DtRailPathControllerPSR:
Definition: railPathControllerPSR.h:28
Class DtVrfProcessStateRepository: Abstract base class for all process state repositories. Process state repositories represent (potentially) shared, savable information for one or more components functioning together to achieve some process or set of processes; such as aiming and firing a weapon; moving an object; or just waiting a specified amount of time.
Definition: vrfProcessStateRepository.h:45
virtual DtString type() const =0
Returns the string type of the repository, as defined in psrTypes.h.
DtRwSimObjectReference myDebugPath
Parameter Name: destination-name Parameter Description: Stores the name of the destination object if ...
Definition: railPathControllerPSR.h:121
DtRwRailSegmentList myPathList
Parameter Name: path Parameter Description: Stores the calculated rail path .
Definition: railPathControllerPSR.h:131
File: rwVector.h.
const DtVrfProcessStateRepository & operator=(const DtVrfProcessStateRepository &orig)
A locally simulated VRF object.
Definition: localObject.h:98

Document ID: Generated on Thu Oct 23 22:29:17 EDT 2025 from SVN revision 280951
Copyright © 2005-2024 MAK Technologies. All Rights Reserved (www.mak.com)